#pragma semicolon 1
#include <sourcemod>
#include <sdktools>
#include <vip_core>

#pragma newdecls required

public Plugin myinfo =
{
	name = "[VIP] Weapon Jumping",
	author = "R1KO",
	version = "1.1"
};
/*
#define LIMIT_MODE 					0 // Режим работы лимита: 0 - для каждого оружия отдельно, 1 - для всех оружий суммарно
*/
static const char g_sFeature[] = "WeaponJumping";

#define WEAPON_INFO_KNOCKBACK		0
#define WEAPON_INFO_VELOCITY		1
#define WEAPON_INFO_GROUND			2

#define WEAPON_INFO_MAXIMUM 		3

int m_hActiveWeapon;
int m_iClip1;

StringMap g_hWeaponInfo;

public void OnPluginStart()
{
	m_hActiveWeapon = FindSendPropInfo("CCSPlayer", "m_hActiveWeapon");
	m_iClip1 = FindSendPropInfo("CBaseCombatWeapon", "m_iClip1");

	HookEvent("weapon_fire", Event_WeaponFire);

	g_hWeaponInfo = new StringMap();

	if(VIP_IsVIPLoaded())
	{
		VIP_OnVIPLoaded();
	}
}

public void VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(g_sFeature, INT);
}

public void OnPluginEnd() 
{
	if(CanTestFeatures() && GetFeatureStatus(FeatureType_Native, "VIP_UnregisterFeature") == FeatureStatus_Available)
	{
		VIP_UnregisterFeature(g_sFeature);
	}
}

public void OnConfigsExecuted()
{
	char szConfigFile[PLATFORM_MAX_PATH];

	KeyValues hKeyValues = new KeyValues("weapons");

	g_hWeaponInfo.Clear();

	BuildPath(Path_SM, szConfigFile, sizeof(szConfigFile), "data/vip/modules/weapon_jumping.ini");

	if (!hKeyValues.ImportFromFile(szConfigFile))
	{
		SetFailState("Не удалось открыть файл '%s'", szConfigFile);
	}

	if (hKeyValues.GotoFirstSubKey())
	{
		char	szWeaponName[32];
		int		arWeaponInfo[WEAPON_INFO_MAXIMUM];
		
		do
		{
			if (hKeyValues.GetSectionName(szWeaponName, sizeof(szWeaponName)))
			{
				float flKnockback = hKeyValues.GetFloat("knockback", 0.00);
				float flVelocity  = hKeyValues.GetFloat("velocity",  0.00);
				bool  bGround     = view_as<bool>(hKeyValues.GetNum("ground"));
				if (flVelocity < 0.00)
				{
					flVelocity = 0.00;
				}
				else if (flVelocity > 1.00)
				{
					flVelocity = 1.00;
				}

				arWeaponInfo[WEAPON_INFO_KNOCKBACK] = view_as<int>(flKnockback);
				arWeaponInfo[WEAPON_INFO_VELOCITY]  = view_as<int>(flVelocity);
				arWeaponInfo[WEAPON_INFO_GROUND]    = view_as<int>(bGround);

				g_hWeaponInfo.SetArray(szWeaponName, arWeaponInfo, WEAPON_INFO_MAXIMUM);
			}
		} while (hKeyValues.GotoNextKey());
	}
	
	delete hKeyValues;
}

public void Event_WeaponFire(Event hEvent, const char[] sEvName, bool bDontBroadcast)
{
	int iClient = GetClientOfUserId(hEvent.GetInt("userid"));

	if (VIP_IsClientVIP(iClient) && VIP_IsClientFeatureUse(iClient, g_sFeature))
	{
		int iWeapon = GetEntDataEnt2(iClient, m_hActiveWeapon);
		if (iWeapon > 0)
		{
			int iClip1 = GetEntData(iWeapon, m_iClip1);

			if (iClip1 > 0)
			{
				char szWeaponName[64];
				int  arWeaponInfo[WEAPON_INFO_MAXIMUM];

				hEvent.GetString("weapon", szWeaponName, 32);
				if(!strncmp(szWeaponName, "weapon_", 7))
				{
					strcopy(szWeaponName, 32, szWeaponName[7]);
				}
	
				if (g_hWeaponInfo.GetArray(szWeaponName, arWeaponInfo, WEAPON_INFO_MAXIMUM) || g_hWeaponInfo.GetArray("all", arWeaponInfo, WEAPON_INFO_MAXIMUM))
				{
					bool bGround = view_as<bool>(arWeaponInfo[WEAPON_INFO_GROUND]);

					if (!(GetEntityFlags(iClient) & FL_ONGROUND) || bGround)
					{
						int iMaxShots = VIP_GetClientFeatureInt(iClient, g_sFeature);
						if(iMaxShots != -1)
						{
							StringMap hTrie = VIP_GetVIPClientTrie(iClient);
							/*
							#if LIMIT_MODE == 0
							Format(szWeaponName, sizeof(szWeaponName), "%s->%s", g_sFeature, szWeaponName);
							#else
							FormatEx(szWeaponName, sizeof(szWeaponName), "%s->Shots", g_sFeature);
							#endif
							*/
							FormatEx(szWeaponName, sizeof(szWeaponName), "%s->Shots", g_sFeature);

							int iShots = 0;
							if(hTrie.GetValue(szWeaponName, iShots))
							{
								if(iShots >= iMaxShots)
								{
									return;
								}
							}

							hTrie.SetValue(szWeaponName, iShots+1);
						}

						float flKnockback = view_as<float>(arWeaponInfo[WEAPON_INFO_KNOCKBACK]);
						float flVelocity  = view_as<float>(arWeaponInfo[WEAPON_INFO_VELOCITY]);

						float fVelocity[3], fEyeAngles[3], fForward[3];

						GetEntPropVector(iClient, Prop_Data, "m_vecVelocity", fVelocity);
						GetClientEyeAngles(iClient, fEyeAngles);
						GetAngleVectors(fEyeAngles, fForward, NULL_VECTOR, NULL_VECTOR);

						fVelocity[0] = fVelocity[0] * flVelocity - fForward[0] * flKnockback;
						fVelocity[1] = fVelocity[1] * flVelocity - fForward[1] * flKnockback;
						fVelocity[2] = fVelocity[2] * flVelocity - fForward[2] * flKnockback;

						TeleportEntity(iClient, NULL_VECTOR, NULL_VECTOR, fVelocity);
					}
				}
			}
		}
	}
}

public void VIP_OnPlayerSpawn(int iClient, int iTeam, bool bIsVIP)
{
	if(bIsVIP && VIP_GetClientFeatureStatus(iClient, g_sFeature) != NO_ACCESS)
	{
		char szWeaponName[128];
		FormatEx(szWeaponName, sizeof(szWeaponName), "%s->Shots", g_sFeature);
		VIP_GetVIPClientTrie(iClient).Remove(szWeaponName);
	}
}